---
title: 'CSP: navigate-to'
slug: Web/HTTP/Headers/Content-Security-Policy/navigate-to
tags:
  - CSP
  - Content-Security-Policy
  - Directive
  - HTTP
  - Navigation
  - Reference
  - Security
---
<div>{{HTTPSidebar}}</div>

<p>The HTTP {{HTTPHeader("Content-Security-Policy")}} (CSP) <code><strong>navigate</strong></code><strong><code>-to</code></strong> directive restricts the URLs to which a document can initiate navigations by any means including {{HTMLElement("form")}} (if {{CSP("form-action")}} is not specified), {{HTMLElement("a")}}, {{DOMxRef("window.location")}}, {{DOMxRef("window.open")}}, etc. This is an enforcement on what navigations this document initiates <strong>not</strong> on what this document is allowed to navigate to.</p>

<div class="notecard note">
<p><strong>Note:</strong> If the {{CSP("form-action")}} directive is present, the <code>navigate-to</code> directive will not act on navigations that are form submissions.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">CSP version</th>
   <td>3</td>
  </tr>
  <tr>
   <th scope="row">Directive type</th>
   <td>{{Glossary("Navigation directive")}}</td>
  </tr>
  <tr>
   <th scope="row">{{CSP("default-src")}} fallback</th>
   <td>No. Not setting this allows anything.</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<p>One or more sources can be set for the <code>navigate-to</code> policy:</p>

<pre class="syntaxbox">Content-Security-Policy: navigate-to &lt;source&gt;;
Content-Security-Policy: navigate-to &lt;source&gt; &lt;source&gt;;
</pre>

<h3 id="Sources">Sources</h3>

<p>{{page("Web/HTTP/Headers/Content-Security-Policy/default-src", "Sources")}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Meta_tag_configuration">Meta tag configuration</h3>

<pre class="brush: html">&lt;meta http-equiv="Content-Security-Policy" content="navigate-to 'none'"&gt;
</pre>

<h3 id="Violation_case">Violation case</h3>

<p>Using a {{HTMLElement("form")}} element with an action set to inline JavaScript will result in a CSP violation.</p>

<pre class="brush: html; example-bad">&lt;meta http-equiv="Content-Security-Policy" content="navigate-to 'none'"&gt;

&lt;form action="javascript:alert('Foo')" id="form1" method="post"&gt;
  &lt;input type="text" name="fieldName" value="fieldValue"&gt;
  &lt;input type="submit" id="submit" value="submit"&gt;
&lt;/form&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{specName("CSP 3.0", "#directive-navigate-to", "navigate-to")}}</td>
   <td>{{Spec2("CSP 3.0")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.csp.Content-Security-Policy.navigate-to")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPheader("Content-Security-Policy")}}</li>
 <li>{{CSP("form-action")}}</li>
 <li>{{HTMLElement("a")}} <code>href</code> attribute</li>
 <li>{{HTMLElement("form")}}</li>
 <li>{{DOMxRef("window.location")}}</li>
 <li>{{DOMxRef("window.open")}}</li>
</ul>
